
struct vsplash
{
  GtkWidget *win;
  GtkWidget *img;
};

struct vpr
{
  GtkWidget *win,
            *scrollw,
            *fbox,
            *lbl1,
            *lbl2,
            *lbl3,
            *lbl4,
            *lbl5,
            *lbl6,
            *lbl7,
            *lbl8,
            *lbl9,
            *lbl10,
            *lbl11,
            *lbl12,
            *lbl13,
            *lbl14,
            *txtpaq,
            *txtprior,
            *img, *img2,
            *cmbseccion,
            *cmbarq,
            *txtcontacto,
            *txtver,
            *txtdep,
            *txtrec,
            *txtsug,
            *txtpini,
            *txtdcort,
            *tviewdlarg,
            *btncreaestru,
            *imgicoestru,
            *btncreapq,
            *imgpq,
            *spin,
            *selfil;
            GtkTextBuffer *bufdlarg;
            GtkWidget *lblog;
};

struct var
{
   gchar* ruta;
   const gchar* ejec;
   const gchar* prior; 
   const gchar* sec;
   const gchar* mant; 
   const gchar* arq;
   const gchar* ver;
   const gchar* dep;
   const gchar* sug;
   const gchar* rec;
   const gchar* pini;
   const gchar* dcort;
   const gchar* dlarg;
   gchar rutafull[5000];
};

struct var reg;

struct vsplash win_splash;
struct vpr win_princp;
GtkWidget *crea_splash(const gchar *tit);
GtkWidget *crea_princp(const gchar *tit);

static void destroy(GtkWidget *w, gpointer data)
{

  gtk_main_quit();
}


static void creastruct(GtkWidget *w, gpointer data)
{
  GtkTextIter start;
  GtkTextIter end;
  GtkWidget *msg;


  reg.ejec = gtk_entry_get_text(GTK_ENTRY(win_princp.txtpaq));
  reg.prior = gtk_entry_get_text(GTK_ENTRY(win_princp.txtprior));
  reg.sec = gtk_combo_box_text_get_active_text (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion));
  reg.arq = gtk_combo_box_text_get_active_text (GTK_COMBO_BOX_TEXT(win_princp.cmbarq));
  reg.ver = gtk_entry_get_text(GTK_ENTRY(win_princp.txtver));
  reg.mant = gtk_entry_get_text(GTK_ENTRY(win_princp.txtcontacto));
  reg.dep = gtk_entry_get_text(GTK_ENTRY(win_princp.txtdep));
  reg.sug = gtk_entry_get_text(GTK_ENTRY(win_princp.txtsug));
  reg.rec = gtk_entry_get_text(GTK_ENTRY(win_princp.txtrec));
  reg.pini = gtk_entry_get_text(GTK_ENTRY(win_princp.txtpini));
  reg.dcort = gtk_entry_get_text(GTK_ENTRY(win_princp.txtdcort));
  
  gtk_label_set_label(GTK_LABEL(win_princp.lblog), "---");

  if(reg.ruta == NULL || strcmp(reg.ruta, "") == 0) 
  {
    msg = gtk_message_dialog_new(GTK_WINDOW(win_princp.win), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
                                 GTK_BUTTONS_OK, "No hay ruta dónde guardar");
  
    gtk_dialog_run (GTK_DIALOG (msg));
    gtk_widget_destroy (msg);

    return;
  }


  if(reg.ejec == NULL || strcmp(reg.ejec, "") == 0) 
  {
    msg = gtk_message_dialog_new(GTK_WINDOW(win_princp.win), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
                                 GTK_BUTTONS_OK, "No hay nombre de ejecutable principal definido");
  
    gtk_dialog_run (GTK_DIALOG (msg));
    gtk_widget_destroy (msg);

    return;
  }

  if(reg.arq == NULL || strcmp(reg.arq, "") == 0) 
  {
    msg = gtk_message_dialog_new(GTK_WINDOW(win_princp.win), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
                                 GTK_BUTTONS_OK, "Arquitectura vacía.");
  
    gtk_dialog_run (GTK_DIALOG (msg));
    gtk_widget_destroy (msg);

    return;
  }

  if(reg.sec == NULL || strcmp(reg.sec, "") == 0) 
  {
    msg = gtk_message_dialog_new(GTK_WINDOW(win_princp.win), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
                                 GTK_BUTTONS_OK, "Sección vacía.");
  
    gtk_dialog_run (GTK_DIALOG (msg));
    gtk_widget_destroy (msg);

    return;
  }

  gtk_text_buffer_get_start_iter (win_princp.bufdlarg, &start);
  gtk_text_buffer_get_end_iter (win_princp.bufdlarg, &end);

  reg.dlarg = gtk_text_buffer_get_text(GTK_TEXT_BUFFER(win_princp.bufdlarg), &start, &end,  FALSE);

  strcpy(reg.rutafull, reg.ruta);

  deb_crea_paq(reg.rutafull, reg.ejec, reg.prior, reg.sec, reg.mant, reg.arq,
               reg.ver, reg.dep, reg.rec, reg.sug, reg.pini, reg.dcort, reg.dlarg);
  strcat(reg.rutafull, reg.ejec);

  gtk_widget_set_visible(win_princp.btncreapq, TRUE);
 
}

gpointer hilocreapaq(gpointer data)
{
 FILE *log;
 gchar buf[2000] = {'\0'};
 gint i = 0;




  deb_pack_paq(reg.rutafull, reg.ruta);
  reg.ejec = NULL;

 log = fopen("/tmp/logpqdeb", "r");
 if(log == NULL) return NULL;

  while(!feof(log))
  {
    buf[i] = fgetc(log);
    if(buf[i] == EOF) break;
    if(i >= 2000) break;
    ++i;    
  }
  buf[i] = '\0';
  fclose(log);
  gtk_label_set_label(GTK_LABEL(win_princp.lblog), buf);
  gtk_spinner_stop(GTK_SPINNER(win_princp.spin));

}

void selcarpdest(GtkFileChooserButton *w, gpointer data)
{
  gchar cdest[500] = {'\0'};

  strcpy(cdest, gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(win_princp.selfil)));
  strcat(cdest, "/"); /* Agregar barra faltante de la ruta */
  reg.ruta = (gchar *) g_malloc(sizeof(gchar) * 500);
  strcpy(reg.ruta, cdest);
}

static void creapq(GtkWidget *w, gpointer data)
{
  GThread *hilopaq;

  gtk_spinner_start(GTK_SPINNER(win_princp.spin));
  hilopaq = g_thread_try_new("creapaquete", hilocreapaq, NULL, NULL);
  if(hilopaq == NULL) return;
  gtk_widget_set_visible(win_princp.btncreapq, FALSE);
  

}

 GtkWidget *crea_splash(const gchar *tit)
{
  win_splash.win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(win_splash.win), tit);
  gtk_window_set_default_size(GTK_WINDOW(win_splash.win), 250, 205);
  gtk_window_set_resizable(GTK_WINDOW(win_splash.win), FALSE);
  gtk_window_set_icon_from_file(GTK_WINDOW(win_splash.win), "indeb.png", NULL);
  gtk_window_set_position(GTK_WINDOW(win_splash.win), GTK_WIN_POS_CENTER);
  gtk_window_set_modal(GTK_WINDOW(win_splash.win), TRUE);
  win_splash.img = gtk_image_new_from_file ("splash.png");
  gtk_container_add (GTK_CONTAINER (win_splash.win), win_splash.img);

  return win_splash.win;
}

 GtkWidget *crea_princp(const gchar *tit)
{
  win_princp.win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(win_princp.win), tit);
  gtk_window_set_default_size(GTK_WINDOW(win_princp.win), 640, 400);
  gtk_window_set_resizable(GTK_WINDOW(win_princp.win), TRUE);
  gtk_window_set_icon_from_file(GTK_WINDOW(win_princp.win), "indeb.png", NULL);
  gtk_window_set_position(GTK_WINDOW(win_princp.win), GTK_WIN_POS_CENTER);

  win_princp.scrollw = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (win_princp.win), win_princp.scrollw);

  win_princp.fbox = gtk_flow_box_new();
  gtk_flow_box_set_homogeneous(GTK_FLOW_BOX(win_princp.fbox), FALSE);
  gtk_flow_box_set_max_children_per_line(GTK_FLOW_BOX(win_princp.fbox), 2);
  gtk_flow_box_set_selection_mode(GTK_FLOW_BOX(win_princp.fbox), GTK_SELECTION_NONE);

  win_princp.img = gtk_image_new_from_file ("indeb.png");
  gtk_container_add (GTK_CONTAINER (win_princp.win), win_princp.img);
  win_princp.img2 = gtk_image_new_from_file ("deb.png");
  gtk_container_add (GTK_CONTAINER (win_princp.win), win_princp.img2);

  gtk_container_add (GTK_CONTAINER (win_princp.scrollw), win_princp.fbox);

  win_princp.lbl1 = gtk_label_new("Nombre de aplicación o paquete:");
  win_princp.txtpaq = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtpaq), 15);
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtpaq), "mipaquete");
  gtk_widget_set_tooltip_text(win_princp.txtpaq, "Ejecutable principal o bien nombre del paquete final sin el .deb");

  win_princp.lbl2 = gtk_label_new("Ruta de salida del paquete:");
  win_princp.selfil = gtk_file_chooser_button_new("Seleccione carpeta de destino", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
  g_signal_connect(win_princp.selfil, "file-set", G_CALLBACK(selcarpdest), NULL);

  win_princp.lbl3 = gtk_label_new("Prioridad del paquete en el sistema:");
  win_princp.txtprior = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtprior), "optional");
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtprior), 250);

  win_princp.lbl4 = gtk_label_new("Sección o categoría:");
  win_princp.cmbseccion = gtk_combo_box_text_new_with_entry();

  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "misc");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "x11");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "net");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "gnome");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "graphics");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "fonts");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "video");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "sound");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "office");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "math");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbseccion), NULL, "database");

  win_princp.lbl5 = gtk_label_new("Arquitectura:");
  win_princp.cmbarq = gtk_combo_box_text_new_with_entry();
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbarq), NULL, "all");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbarq), NULL, "amd64");
  gtk_combo_box_text_append (GTK_COMBO_BOX_TEXT(win_princp.cmbarq), NULL, "i386");


  win_princp.lbl6 = gtk_label_new("Contacto del autor:");
  win_princp.txtcontacto = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtcontacto), 250);
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtcontacto), "fulano <fulano@gmail.com>");

  win_princp.lbl7 = gtk_label_new("Version del paquete:");
  win_princp.txtver = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtver), 250);
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtver), "1.0");

  win_princp.lbl8 = gtk_label_new("Dependencias:");
  win_princp.txtdep = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtdep), 250);
  gtk_widget_set_tooltip_text(win_princp.txtdep, "Ej libatkmm-1.6-1v5 (>= 2.24.0), libc6 (campo no obligatorio)");

  win_princp.lbl9 = gtk_label_new("Recomendaciones:");
  win_princp.txtrec = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtrec), 250);
  gtk_widget_set_tooltip_text(win_princp.txtrec, "Ej python, libc6 (campo no obligatorio)");

  win_princp.lbl10 = gtk_label_new("Sugerencias:");
  win_princp.txtsug = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtsug), 250);
  gtk_widget_set_tooltip_text(win_princp.txtsug, "Ej libatkmm-1.6-1v5 (>= 2.24.0), libc6 (campo no obligatorio)");

  win_princp.lbl11 = gtk_label_new("Página de inicio:");
  win_princp.txtpini = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtpini), 250);
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtpini), "http://www.google.com");

  win_princp.lbl12 = gtk_label_new("Descripción corta:");
  win_princp.txtdcort = gtk_entry_new();
  gtk_entry_set_max_length(GTK_ENTRY(win_princp.txtdcort), 250);
  gtk_entry_set_text(GTK_ENTRY(win_princp.txtdcort), "Esto es un paquete Debian");

  win_princp.lbl13 = gtk_label_new("Descripción larga:");
  win_princp.tviewdlarg = gtk_text_view_new();
  win_princp.bufdlarg = gtk_text_buffer_new(NULL);
  gtk_text_view_set_buffer(GTK_TEXT_VIEW(win_princp.tviewdlarg), win_princp.bufdlarg);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(win_princp.tviewdlarg), TRUE);
  gtk_text_view_set_overwrite(GTK_TEXT_VIEW(win_princp.tviewdlarg), FALSE);
  gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(win_princp.tviewdlarg), TRUE); 
  gtk_text_buffer_set_text(win_princp.bufdlarg, " Este paquete es para Debian aunque\n puede servir en Ubuntu.\n\n\n\n\n\n\n\n\n\n", -1);
  gtk_widget_set_tooltip_text(win_princp.tviewdlarg, "Mantenga la sangría de un espacio cada linea de este subcomentario para que se pueda crear sin errores el paquete."); 


  win_princp.spin = gtk_spinner_new ();
  gtk_spinner_stop(GTK_SPINNER(win_princp.spin));

  win_princp.btncreaestru = gtk_button_new_with_label(NULL);
  win_princp.imgicoestru = gtk_image_new_from_file ("creastru.png");
  gtk_button_set_image(GTK_BUTTON(win_princp.btncreaestru), win_princp.imgicoestru); 
  gtk_widget_set_tooltip_text(win_princp.btncreaestru, "Crear estructura de carpetas del paquete."); 

  win_princp.btncreapq = gtk_button_new_with_label(NULL);
  win_princp.imgpq = gtk_image_new_from_file ("crear.png");
  gtk_button_set_image(GTK_BUTTON(win_princp.btncreapq), win_princp.imgpq); 
  gtk_widget_set_tooltip_text(win_princp.btncreapq, "Empaquetar como .deb ."); 

  win_princp.lblog = gtk_label_new("---");


  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.img, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.img2, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl1, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtpaq, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl2, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.selfil, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl3, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtprior, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl4, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.cmbseccion, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl5, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.cmbarq, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl6, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtcontacto, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl7, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtver, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl8, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtdep, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl9, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtrec, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl10, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtsug, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl11, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtpini, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl12, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.txtdcort, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lbl13, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.tviewdlarg, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.spin, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.lblog, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.btncreaestru, -1);
  gtk_flow_box_insert(GTK_FLOW_BOX(win_princp.fbox), win_princp.btncreapq, -1);






  g_signal_connect(win_princp.win, "destroy", G_CALLBACK(destroy), NULL);
  g_signal_connect(win_princp.btncreaestru, "clicked", G_CALLBACK(creastruct), NULL);
  g_signal_connect(win_princp.btncreapq, "clicked", G_CALLBACK(creapq), NULL);

  return win_princp.win;
}
